﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using RadDataFormForeignKeyRIAExample.Web;
using Telerik.Windows.Controls.Data;
using Telerik.Windows.Controls;
using System.Windows.Data;

namespace RadDataFormForeignKeyRIAExample
{
    public partial class MainPage : UserControl
    {

        List<string> displayedProperties = new List<string>() { "FirstName", "LastName", "Title", "HomePhone", "ReportsTo", "HireDate" };
        List<EmployeeID> employeeIDs = new List<EmployeeID>()
        {
            new EmployeeID(){Name = "Nancy Davolio", ID = 1},
            new EmployeeID(){Name = "Andrew Fuller", ID = 2},
            new EmployeeID(){Name = "Janet Leverling", ID = 3},
            new EmployeeID(){Name = "Margaret Peacock", ID = 4},
            new EmployeeID(){Name = "Steven Buchanan", ID = 5},
            new EmployeeID(){Name = "Michael Suyama", ID = 6},
            new EmployeeID(){Name = "Robert King", ID = 7},
            new EmployeeID(){Name = "Laura Callahan", ID = 8},
            new EmployeeID(){Name = "Anne Dodsworth", ID = 9}
        };

        public MainPage()
        {
            InitializeComponent();
        }

        private void MyRadDataForm_AutoGeneratingField(object sender, Telerik.Windows.Controls.Data.DataForm.AutoGeneratingFieldEventArgs e)
        {
            if (!displayedProperties.Contains(e.PropertyName))
            {
                e.Cancel = true;
            }
            if (e.PropertyName == "ReportsTo")
            {
                e.DataField = new DataFormComboBoxField()
                {
                    Label = "ReportsTo",
                    ItemsSource = employeeIDs,
                    DisplayMemberPath = "Name",
                    SelectedValuePath = "ID",
                    DataMemberBinding = new Binding("ReportsTo")
                };
            }
        }

        public class EmployeeID
        {
            public string Name { get; set; }
            public int ID { get; set; }
        }

        private void MyRadDataForm_EditEnded(object sender, Telerik.Windows.Controls.Data.DataForm.EditEndedEventArgs e)
        {
            MyRadDomainDataSource.SubmitChanges();
        }

        private void MyRadDataForm_EditEnding(object sender, Telerik.Windows.Controls.Data.DataForm.EditEndingEventArgs e)
        {
            
            if (e.EditAction == Telerik.Windows.Controls.Data.DataForm.EditAction.Commit)
            {
                if (((sender as RadDataForm).CurrentItem as Employee).FirstName == null || ((sender as RadDataForm).CurrentItem as Employee).LastName == null)
                    e.Cancel = true;
            }
        }

        private void MyRadDataForm_DeletedItem(object sender, Telerik.Windows.Controls.Data.DataForm.ItemDeletedEventArgs e)
        {
            MyRadDomainDataSource.SubmitChanges();
        }
    }
}
